unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, AMixer, MMSystem, Unit3;

type
  TForm1 = class(TForm)
    DestinationCombo: TComboBox;
    ConnectionCombo: TComboBox;
    CanVolLabel: TLabel;
    CanMuteLabel: TLabel;
    DeviceCombo: TComboBox;
    LabelStereo: TLabel;
    InfoBtn: TButton;
    CancelBtn: TButton;
    OKBtn: TButton;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure DestinationComboChange(Sender: TObject);
    procedure ConnectionComboChange(Sender: TObject);
    procedure MixerControlChange(Sender: TObject; MixerH, ID: Integer);
    procedure TrackBarChange(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
    procedure DeviceComboChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure InfoBtnClick(Sender: TObject);
  private
    { Private declarations }
    Setting:Boolean;
  public
    { Public declarations }
    Mixer: TAudioMixer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var A:Integer;
begin
  Mixer:=TAudioMixer.Create(self);

  For A := 0 to Mixer.MixerCount - 1 do
  begin
    Mixer.MixerId:=A;
    DeviceCombo.Items.Add (Mixer.ProductName);
  end;

  If (DeviceCombo.Items.Count > 0) then
    DeviceCombo.ItemIndex := 0;
  DeviceComboChange (Sender);
end;

procedure TForm1.DestinationComboChange(Sender: TObject);
var A:Integer;
begin
  ConnectionCombo.Items.Clear;
  ConnectionCombo.Items.Add (Mixer.Destinations[DestinationCombo.ItemIndex].Data.szName);
  For A:=0 to Mixer.Destinations[DestinationCombo.ItemIndex].Connections.Count-1 do
    ConnectionCombo.Items.Add(Mixer.Destinations[DestinationCombo.ItemIndex].Connections[A].Data.szName);
  If ConnectionCombo.Items.Count>0 then
  begin
    ConnectionCombo.ItemIndex:=0;
    ConnectionComboChange (Self);
  end;
end;

procedure TForm1.ConnectionComboChange(Sender: TObject);
var L,R,M:Integer;
    VD,MD:Boolean;
    Stereo:Boolean;
    IsSelect:Boolean;
begin
  Mixer.GetVolume (DestinationCombo.ItemIndex,ConnectionCombo.ItemIndex-1,L,R,M,Stereo,VD,MD,IsSelect);
  Setting:=True;

  if not VD then
  begin
     CanVolLabel.Caption:='Can set volume';
     CanVolLabel.Font.Color:=clGreen;
  end
  else
  begin
     CanVolLabel.Caption:='Cannot set volume';
     CanVolLabel.Font.Color:=clRed;
  end;
  if not MD then
  begin
     CanMuteLabel.Caption:='Can set mute/select';
     CanMuteLabel.Font.Color:=clGreen;
  end
  else
  begin
     CanMuteLabel.Caption:='Cannot set mute/select';
     CanMuteLabel.Font.Color:=clRed;
  end;
//  If TrackBar.Visible then
//    TrackBar.Position:=L;
//  If CheckBox.Visible then
//    CheckBox.Checked:=M<>0;
  if Stereo then LabelStereo.Caption := '- stereo -' else LabelStereo.Caption := '- mono -';
  Setting:=False;
end;

procedure TForm1.MixerControlChange(Sender: TObject; MixerH, ID: Integer);
begin
  ConnectionComboChange (Self);
end;

procedure TForm1.TrackBarChange(Sender: TObject);
begin
  If (not Setting) then
  begin
    Setting:=True;
//    Mixer.SetVolume (DestinationCombo.ItemIndex,ConnectionCombo.ItemIndex-1,0..65535,0..65535,Integer(True/False));
    Setting:=False;
  end;
end;

procedure TForm1.CheckBoxClick(Sender: TObject);
begin
  If not Setting then
  begin
    Setting:=True;
//    Mixer.SetVolume (DestinationCombo.ItemIndex,ConnectionCombo.ItemIndex-1,TrackBar.Position,TrackBar.Position,Integer(CheckBox.Checked));
    Setting:=False;
  end;
end;


procedure TForm1.DeviceComboChange(Sender: TObject);
var A:Integer;
begin
  If (DeviceCombo.ItemIndex >= 0) AND (DeviceCombo.ItemIndex < Mixer.MixerCount) then
    Mixer.MixerId := DeviceCombo.ItemIndex;
  DestinationCombo.Items.Clear;
  If Mixer.MixerCount>0 then
  begin
    For A:=0 to Mixer.Destinations.Count-1 do
      DestinationCombo.Items.Add (Mixer.Destinations[A].Data.szName);
    If DestinationCombo.Items.Count>0 then
    begin
      DestinationCombo.ItemIndex:=0;
      DestinationComboChange (Self);
    end;
  end
  else
  begin
    DestinationCombo.OnChange:=nil;
    ConnectionCombo.OnChange:=nil;
    MessageDlg ('No mixer present in the system !',mtError,[mbOK],0);
  end;
  Setting:=False;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
//   Mixer.free;
end;

procedure TForm1.InfoBtnClick(Sender: TObject);
var Form: TForm3;
begin
  Form := TForm3.Create (Self);
  Form.ShowModal;
  Form.Free;
end;

end.
